%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 10/1999
%
% Forward.m
%
%   Recebe:
%		data - dados para convolucao
%		  dimensoes esperadas:
%		    size_conv
%         size_pat
%			 size_feature_pos
%
%		w - kernel da convolucao
%		  dimensoes esperadas:
%		    size_conv
%         size_feature_pos
%			 size_feature_pre
%
%   Retorna:
%		result - resultado da convolucao
%		  dimensoes retornadas:
%		    size_conv
%		    size_pat
%			 size_feature_pre
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=Backward(data,w,fft)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
permute_data=[w.permute_pos.conv,w.permute_pos.pos,w.permute_pos.pat];
permute_w=[w.permute_w.conv,w.permute_w.pos,w.permute_w.pre];
permute_result=[w.permute_pre.conv,w.permute_pre.pat,w.permute_pre.pre];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% inicio - permute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data.data=permute(data.data,permute_data);
w.data=permute(w.data,permute_w);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% data:   |conv|pos|pat|
% w:      |conv|pos|pre|
% result: |conv|pat|pre|
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dim.conv=w.conv;
dim.same=0;
dim.contract=w.pos;
dim.expand_data=w.pat;
dim.expand_kernel=w.pre;

for ind_flip=1:dim.conv
   w.data=flipdim(w.data,ind_flip);
end

if(fft)
   result=convm_fft(data,w,dim);
else
   result=convm(data,w,dim);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fim - ipermute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
result.data=ipermute(result.data,permute_result);
