%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FTransic.m
%
% FTransic - Funcao de transicao
%   Recebe:
%     x - entrada da funcao de transicao
%     GrauDerivada - Grau da Derivada a ser aplicada na funcao de
%                    transicao (0 - a propria funcao; 1 - derivada primeira)
%   Retorna:
%     Retorno - Resultado da Funcao sobre x
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=FTransic(data,derivation);

%k=4;
k=2.7;
x=(data.data-0.5)*k;

Beta=1;
Sigmoide=1./(1+exp(-2*Beta*x)); % Sigmoide

result.dim=data.dim;

if (derivation==0)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Funcao de transicao sigmoide
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   result.data=Sigmoide;
elseif (derivation==1)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Derivada primeira da funcao de transicao sigmoide
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   result.data=2*Beta*Sigmoide.*(1-Sigmoide);
else
   disp('uso incorreto');
   pause;
   % Uso incorreto
end

