%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 10/1999
%
% Forward.m
%
%   Recebe:
%		data - dados para convolucao
%		  dimensoes esperadas:
%		    size_conv
%         size_pat
%			 size_feature_pre
%
%		w - kernel da convolucao
%		  dimensoes esperadas (nesta ordem):
%		    size_conv
%         size_feature_pre
%			 size_feature_pos
%
%   Retorna:
%		result - resultado da convolucao
%		  dimensoes retornadas:
%		    size_conv
%		    size_pat
%			 size_feature_pos
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=Forward(data,w,fft)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
permute_data=[w.permute_pre.conv,w.permute_pre.pre,w.permute_pre.pat];
permute_w=[w.permute_w.conv,w.permute_w.pre,w.permute_w.pos];
permute_result=[w.permute_pos.conv,w.permute_pos.pat,w.permute_pos.pos];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% inicio - permute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data.data=permute(data.data,permute_data);
w.data=permute(w.data,permute_w);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% data:   |conv|pre|pat|
% w:      |conv|pre|pos|
% result: |conv|pat|pos|
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dim.conv=w.conv;
dim.same=0;
dim.contract=w.pre;
dim.expand_data=w.pat;
dim.expand_kernel=w.pos;

if(fft)
   result=convm_fft(data,w,dim);
else
   result=convm(data,w,dim);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fim - ipermute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
result.data=ipermute(result.data,permute_result);
