%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 11/1999
%
% convn_fast.m
%
% convn otimizado
% 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=convn_fast(A,B)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if((ndims(A)<=2)&(ndims(B)<=2))
   % voce sabia que o conv2 e' mais rapido que o conv 
   % para os mesmos vetores unidimensionais (no matlab 5.1)?
   
   %disp('conv2');
   result=conv2(A,B,'same');
else
   size_A=size(A);
   size_B=size(B);
   if((sum(size_A~=1)<=2)|(sum(size_B~=1)<=2))
      % A ou B pode ser utilizado para convolucao bidimensional
      ind_permute=1:max(length(size_A),length(size_B));
      if(sum(size_A~=1)<=sum(size_B~=1))
         % A = kernel bidimensional
         % B = dado n dimensional

         
         % conv2 nao implementado
         %disp('conv2 - a');
         result=convn(A,B,'same');
         
      else
         % B = kernel bidimensional
         % A = dado n dimensional
         
         %disp('conv2 - b');
         [Bs,Bi]=sort(size_B);
         
         ind_permute(1:length(Bi))=ind_permute(Bi(end:-1:1));
         
         Ap=permute(A,ind_permute);
         Bp=permute(B,ind_permute);
         size_Ap=num2cell(size(Ap));
         
         Rp=zeros(size_Ap{:});
         
         % loop
         ind_Ap=ndFirst({size_Ap{3:end}}); % first element
         while(1)
            Rp(:,:,ind_Ap{:})=conv2(Ap(:,:,ind_Ap{:}),Bp,'same');
            [ind_Ap,overflow]=ndNext(ind_Ap,{size_Ap{3:end}}); % next element
            if(overflow) break; end % end loop
         end
         
         result=ipermute(Rp,ind_permute);
         
      end
   else
      %disp('convn');

      result=convn(A,B,'same');
   end
end

