%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 12/1999
%
% convn_fft.m
%
% convn implementado com transformada rapida de Fourier
% 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=convn_fft(A,B)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ndim=max(ndims(A),ndims(B));

size_A=ones(1,ndim);
size_B=ones(1,ndim);

size_A(1:ndims(A))=size(A);
size_B(1:ndims(B))=size(B);
n_points=size_A+size_B-1;

fft_A=zeros(n_points);
fft_B=zeros(n_points);

ind_A=ndAll(num2cell(size_A));
ind_B=ndAll(num2cell(size_B));
fft_A(ind_A{:})=A;
fft_B(ind_B{:})=B;

for ind=1:ndim
   fft_A=fft(fft_A,[],ind);
   fft_B=fft(fft_B,[],ind);
end

fft_C=fft_A.*fft_B;

for ind=1:ndim
   fft_C=ifft(fft_C,[],ind);
end   

C=real(fft_C);

offset=floor((n_points+1-size_A)/2);

ind_C=ndRange(num2cell(offset+1),num2cell(offset+size_A));
%ind_result=ndRange(num2cell(ones(1,ndim)),num2cell(size_A));
%result(ind_result{:})=C(ind_C{:});
result=C(ind_C{:});

%max(max(max(abs((result-convn(A,B,'same'))))))
